import * as knex from 'knex';
import { Trilogy } from '.';
import * as types from './types';
export declare function parseResponse(contents: types.SqlJsResponse): types.LooseObject[];
export declare function buildOrder<T = any, U = any>(partial: knex.QueryBuilder<T, U>, order: string | [string] | [string, string]): knex.QueryBuilder<T, U>;
export declare function buildWhere<T = any, U = any>(partial: knex.QueryBuilder<T, U>, where: types.CriteriaBase | types.CriteriaList | undefined, inner?: boolean): knex.QueryBuilder<T, U>;
export declare function isWhereTuple(where: any): where is types.Criteria2 | types.Criteria3;
export declare function isWhereMultiple(where: any): where is types.CriteriaList;
export declare function isValidWhere(where: any): where is types.CriteriaBase;
export declare function normalizeCriteria<D>(where: types.CriteriaObj<D> | types.Criteria2<D>): types.CriteriaObj<D>;
export declare function normalizeCriteria<D>(where: types.Criteria3<D>): types.Criteria3<D>;
export declare function normalizeCriteria<D>(where: types.CriteriaList<D>): types.CriteriaListNormalized<D>;
export declare function normalizeCriteria<D>(where: types.CriteriaBase<D>): types.CriteriaBaseNormalized<D>;
export declare function normalizeCriteria<D>(where: types.Criteria<D>): types.CriteriaNormalized<D>;
export declare function runQuery<D extends types.ReturnDict = types.LooseObject>(instance: Trilogy, query: types.Query, options?: types.QueryOptions<D>): Promise<any>;
export declare function findKey(schema: types.Schema): {
    key: string;
    hasIncrements: boolean;
};
