"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const t = require("runtypes");
const constants_1 = require("./constants");
const util_1 = require("./util");
exports.Index = t.Union(t.String, t.Array(t.Union(t.String, t.Array(t.String))), t.Dictionary(t.Union(t.String, t.Array(t.String))));
exports.GroupClause = t.Union(t.String, t.Array(t.String));
exports.OrderClause = t.Union(t.String, t.Tuple(t.String, t.String));
exports.TrilogyOptions = t.Partial({
    client: t.Union(t.Literal('sqlite3'), t.Literal('sql.js')),
    dir: t.String
});
exports.ModelOptions = t.Partial({
    index: exports.Index,
    primary: t.Array(t.String),
    unique: t.Array(t.String),
    timestamps: t.Boolean
});
exports.AggregateOptions = t.Partial({
    distinct: t.Boolean,
    group: exports.GroupClause,
    order: exports.OrderClause
});
exports.CreateOptions = t.Partial({
    raw: t.Boolean
});
exports.FindOptions = t.Partial({
    limit: t.Number,
    order: exports.OrderClause,
    random: t.Boolean,
    raw: t.Boolean,
    skip: t.Number
});
exports.UpdateOptions = t.Partial({
    raw: t.Boolean
});
exports.ColumnKind = t.Union(t.String, t.Function).withConstraint(value => {
    const type = util_1.isFunction(value) ? value.name : String(value);
    return type.toLowerCase() in constants_1.ColumnTypes;
}, { name: 'ColumnKind' });
exports.ColumnDescriptor = t.Partial({
    defaultTo: t.Unknown,
    index: t.String,
    notNullable: t.Boolean,
    nullable: t.Boolean,
    primary: t.Boolean,
    unique: t.Boolean,
    type: exports.ColumnKind,
    get: t.Function,
    set: t.Function
});
